var mylistAddStatus = {
	'loading':'追加中です…。',
	'success':'<a href="%HREF%">%NAME%</a> に登録しました。',
	'duperror':'すでに登録されています。',
	'maxerror':'最大登録数をオーバーしています。',
	'error':'登録に失敗しました。',
	'success_new':'<a href="%HREF%">%NAME%</a> を作成して登録しました。 (<a href="/mylistgroup_edit">編集</a>)'
};
var mylistDelError = '削除できませんでした';
var mylistEditError = '変更できませんでした';

String.prototype.replaceMacro = function (macro) {
	return this.replace(/%(\w*)%/g, function ($0, $1) {
		if (!$1) return '%';
		$1 = $1.toLowerCase();
		if ($1 in macro) return macro[$1];
		return $0;
	});
};

function setMylistAddStatus(status, macro, count) {
	var text = (mylistAddStatus[status.toLowerCase()] || status);
	if (macro) text = text.replaceMacro(macro);
	
	balloon("mylist_add_submit", text, "lT");
}

function onMylistAddSubmit(form) {
	if ($F("mylist_add_group_id") == "new") {
		var n = $$("#mylist_add_group_id option").max(function (opt) {
			return /^新しいマイリスト\((\d+)\)$/.test(opt.innerHTML) ? parseInt(RegExp.$1) : 0;
		});
		form.mylistgroup_name.value = "新しいマイリスト(" + (n+1) + ")";
	}

	var params = Form.serialize(form) + '&ajax=1';
	Form.disable(form);
	setMylistAddStatus('loading');
	new Ajax.Request(form.action, {
		parameters: params,
		onComplete: function (req) {
			Form.enable(form);
			if (req.status == 200) {
				try {
					completeMylistAdd( eval(req.responseText) );
					return;
				} catch (e) { }
			}
			setMylistAddStatus('error');
		}
	});
	return false;
}

function completeMylistAdd(result) {
	if (result && result.result == 'success') {
		var mylist = result.mylist;
		var groups = $('mylist_add_group_id');
		var selected = groups.down('option[value="' + mylist.group_id + '"]');
		if (selected) {
			selected.update(mylist.name);
			setMylistAddStatus('success', mylist, result.count);
		} else {
			var option = document.createElement("option");
			option.value = mylist.group_id;
			option.innerHTML = mylist.name;
			groups.insertBefore(option, groups.down("option"));
			groups.value = option.value;
			if (result.at_max) {
				$("mylist_add_new_group").hide();
			}
			setMylistAddStatus('success_new', mylist);
		}
	} else {
		setMylistAddStatus(result && result.result ? result.result : 'error',
			null, result.count);
	}
}

